# Get auth strategies

`GET /v1/authcredentials/strategies`

Available as MCP tool `get-auth-strategies` (Read).

Credential endpoints allow you to manage custom authentication strategies for your organization's destinations. Destinations are the endpoints in your system that receive data from Redox. 

You may choose custom authentication for your destinations if you want more secure authentication credentials for any data coming into your system. 

With this set of Platform API endpoints, you can:

- retrieve a list of existing auth credentials for an environment;
- retrieve one auth credential by its ID;
- retrieve a list of supported auth strategies;
- create a new auth credential;
- update an existing auth credential; or
- delete an existing auth credential.

### Get auth strategies

Retrieve a list of supported auth strategies that you can configure for your destinations.

> **Internal attributes**
>
> Any attributes beginning with `x-redox` are for internal use by Redox dashboards.

## Request example

```bash
curl 'https://api.redoxengine.com/platform/v1/authcredentials/strategies' \
--request GET \
--header 'Authorization: Bearer $API_TOKEN' \
--header 'accept: application/json'
```

## Responses

### 200

Contains a `payload` object with the available authentication strategies.

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `meta` | object | No |  |
| `meta.version` | string | No | Lists the major and minor version number for the format of the returned payload. The payload format or shape may change between minor versions, like including additional or extended fields in later versions. We include the version data in each response so that you have the option to handle the signaled differences. |
| `payload` | object | No | Contains the response body with the list of available auth credential strategies that you can use. |
| `payload.strategies` | object | No | Contains the supported auth credential strategies and their respective available fields. You can use any of these auth strategies when setting up custom authentication for a destination that receives data from Redox. |
| `payload.strategies.AwsSigv4` | object | No |  |
| `payload.strategies.AwsSigv4.availableFields` | Array of string | No | Displays the available fields for this strategy, which are `accessKey`, `secretKey`, `serviceName`, `awsRegion` and `sessionToken`. |
| `payload.strategies.GoogleWIF` | object | No |  |
| `payload.strategies.GoogleWIF.availableFields` | Array of string | No | Displays the available fields for this strategy, which are `audience`, `delegates`, `lifetime`, `options`, `scope`, `service_account_impersonation_url`, `sts_scope`, and `token_url`. |
| `payload.strategies.OAuth_2.0_2-legged` | object | No |  |
| `payload.strategies.OAuth_2.0_2-legged.availableFields` | Array of string | No | Displays the available fields for this strategy, which are `grantType`, `username`, `password`, `url`, `grantTypeName`, `clientIdName`, `clientSecretName`, `refreshTokenName`, `clientId`, `clientSecret`, `accessTokenName`, `expiresFieldName`, `refreshGrantType`, `audience`, `scopes`, `contentType`, `noBasic`, `resource`, `customFieldName`,`customFieldValue`, and `defaultExpirationSeconds`. |
| `payload.strategies.Oauth_2.0_JWT_GCP` | object | No |  |
| `payload.strategies.Oauth_2.0_JWT_GCP.availableFields` | Array of string | No | Displays the available fields for this strategy. |
| `payload.strategies.SMART_Backend` | object | No |  |
| `payload.strategies.SMART_Backend.availableFields` | Array of string | No | Displays the available fields for this strategy, which are `grantType`, `username`, `password`, `url`, `grantTypeName`, `clientIdName`, `clientSecretName`, `refreshTokenName`, `clientId`, `clientSecret`, `accessTokenName`, `expiresFieldName`, `refreshGrantType`, `audience`, `scopes`, `contentType`, `noBasic`, `resource`, `customFieldName`, `customFieldValue`, `defaultExpirationSeconds`, `privateKey`, `algorithm`, `keyId`, `clientCert`, and `clientCertKey`. |
| `payload.strategies.JWT_Bearer` | object | No |  |
| `payload.strategies.JWT_Bearer.availableFields` | Array of string | No | Displays the available fields for this strategy, which are `privateKey`, `algorithm`, `keyID`, `clientCert`, `ClientCertKey`, `clientID`, `clientSecret`, and `url`. |
| `payload.strategies.AwsSigV4` | object | No |  |
| `payload.strategies.AwsSigV4.availableFields` | Array of string | No | Displays the available fields for this strategy, which are `accessKey`, `secretKey`, `serviceName`, `awsRegion` and `sessionToken`. |

_Generated from the schema: the values are placeholders, not a real payload._

```json
{
  "meta": {
    "version": "1.0.0"
  },
  "payload": {
    "strategies": {
      "AwsSigv4": {
        "availableFields": [
          "accessKey",
          "secretKey",
          "serviceName",
          "awsRegion",
          "sessionToken"
        ]
      },
      "GoogleWIF": {
        "availableFields": [
          "audience",
          "delegates",
          "lifetime",
          "options",
          "scope",
          "service_account_impersonation_url",
          "sts_scope",
          "token_url"
        ]
      },
      "OAuth_2.0_2-legged": {
        "availableFields": [
          "grantType",
          "username",
          "password",
          "url",
          "grantTypeName",
          "clientIdName",
          "clientSecretName",
          "refreshTokenName",
          "clientId",
          "clientSecret",
          "accessTokenName",
          "expiresFieldName",
          "refreshGrantType",
          "audience",
          "scopes",
          "contentType",
          "noBasic",
          "resource",
          "customFieldName",
          "customFieldValue",
          "defaultExpirationSeconds"
        ]
      },
      "Oauth_2.0_JWT_GCP": {
        "availableFields": [
          "grantType",
          "url",
          "grantTypeName",
          "clientIdName",
          "clientSecretName",
          "refreshTokenName",
          "clientId",
          "clientSecret",
          "accessTokenName",
          "expiresFieldName",
          "refreshGrantType",
          "audience",
          "scopes",
          "contentType",
          "noBasic",
          "resource",
          "customFieldName",
          "customFieldValue",
          "defaultExpirationSeconds",
          "basicNoForm",
          "password",
          "username",
          "customGrantType",
          "privateKey",
          "algorithm",
          "keyId",
          "clientCert",
          "clientCertKey"
        ]
      },
      "SMART_Backend": {
        "availableFields": [
          "grantType",
          "username",
          "password",
          "url",
          "grantTypeName",
          "clientIdName",
          "clientSecretName",
          "refreshTokenName",
          "clientId",
          "clientSecret",
          "accessTokenName",
          "expiresFieldName",
          "refreshGrantType",
          "audience",
          "scopes",
          "contentType",
          "noBasic",
          "resource",
          "customFieldName",
          "customFieldValue",
          "defaultExpirationSeconds",
          "privateKey",
          "algorithm",
          "keyId",
          "clientCert",
          "clientCertKey"
        ]
      },
      "JWT_Bearer": {
        "availableFields": [
          "privateKey",
          "algorithm",
          "keyId",
          "clientCert",
          "clientCertKey",
          "clientId",
          "clientSecret",
          "url"
        ]
      },
      "AwsSigV4": {
        "availableFields": [
          "accessKey",
          "secretKey",
          "serviceName",
          "awsRegion",
          "sessionToken"
        ]
      }
    }
  }
}
```

### 400

Bad Request

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `payload` | object | No | Contains the error message. |
| `payload.error` | object | No | Contains the error message details. |
| `payload.error.title` | string | No | Displays the high-level error message, typically something succinct like `Bad Request`. |
| `payload.error.code` | string | No | Contains an alternative ID for the error type, which can be used to find relevant troubleshooting information. |
| `payload.error.detail` | string | No | Contains the specific error details for this message. |
| `payload.error.status` | number | No | Displays the corresponding HTTP status code for the error. |
| `payload.error.transient` | boolean | No | Describes whether the error will resolve itself. If `true`, no further action needs to be taken. If `false`, you may need to troubleshoot on your end to resolve the issue before the error can be processed. |

```json
{
  "payload": {
    "error": {
      "title": "Bad Request",
      "code": "validation.error.bad.request",
      "detail": "Error details",
      "status": 400,
      "transient": false
    }
  }
}
```
